---
title: Updating extensions for Firefox 3
slug: Mozilla/Firefox/Releases/3/Updating_extensions
tags:
  - Firefox 3
---
<div>{{FirefoxSidebar}}</div>

<div>{{Fx_minversion_header(3)}}</div>

<p>This article provides information that will be useful to developers that wish to update their extensions to work properly under Firefox 3.</p>

<p>Before going further, there's one helpful hint we can offer: if the only change your extension requires is a bump to the <code>maxVersion</code> field in its install manifest, and you host your extension at <a class="link-https" href="https://addons.mozilla.org">addons.mozilla.org</a>, you don't actually need to upload a new version of your extension! Use the Developer Control Panel at AMO to adjust the <code>maxVersion</code>. You can avoid having to have your extension re-reviewed this way.</p>

<h2 id="Step_1_Update_the_install_manifest">Step 1: Update the install manifest</h2>

<p>The first step -- and, for most extensions, the only one that will be needed -- is to update the <a href="/en-US/docs/Install_Manifests" title="Install_Manifests">install manifest</a> file, <a href="/en-US/docs/Creating_a_Skin_for_Firefox/install.rdf"><code>install.rdf</code></a>, to indicate compatibility with Firefox 3.</p>

<p>Find the line indicating the maximum compatible version of Firefox (which, for Firefox 2, might look like this):</p>

<div style="overflow: hidden;">
<pre class="brush:xml">&lt;em:maxVersion&gt;2.0.*&lt;/em:maxVersion&gt;
</pre>
</div>

<p>Change it to indicate compatibility with Firefox 3:</p>

<div style="overflow: hidden;">
<pre class="brush:xml">&lt;em:maxVersion&gt;3.0.*&lt;/em:maxVersion&gt;
</pre>
</div>

<p>Then reinstall your extension.</p>

<p>Note that Firefox 3 does away with the extra ".0" in the version number, so instead of using "3.0.0.*, you only need to use "3.0.*".</p>

<p>There have been (and will continue to be) a number of API changes that will likely break some extensions. We're still working on compiling a complete list of these changes.</p>

<div class="note"><span class="lang lang-en"><strong>Note:</strong> If your extension still uses an <code><a href="/en-US/docs/Install.js" rel="internal">Install.js</a></code> script instead of an <a href="/en-US/docs/Install_Manifests" rel="internal">install manifest</a>, you need to make the transition to an install manifest now. Firefox 3 no longer supports <code>install.js</code> scripts in XPI files.</span></div>

<h3 id="Add_localizations_to_the_install_manifest">Add localizations to the install manifest</h3>

<p>Firefox 3 supports new properties in the install manifest to specify localized descriptions. The old methods still work however the new allow Firefox to pick up the localizations even when the add-on is disabled and pending install. See <a href="/en-US/docs/Localizing_extension_descriptions" title="Localizing_extension_descriptions">Localizing extension descriptions</a> for more details.</p>

<h2 id="Step_2_Ensure_you_are_providing_secure_updates">Step 2: Ensure you are providing secure updates</h2>

<p>If you are hosting addons yourself and not on a secure add-on hosting provider like <a class="link-https" href="https://addons.mozilla.org">addons.mozilla.org</a> then you must provide a secure method of updating your add-on. This will either involve hosting your updates on an SSL website, or using cryptographic keys to sign the update information. Read <a href="/en-US/docs/Extension_Versioning,_Update_and_Compatibility#Securing_Updates" title="Extension_Versioning,_Update_and_Compatibility#Securing_Updates">Securing Updates</a> for more information.</p>

<h2 id="Step_3_Deal_with_changed_APIs">Step 3: Deal with changed APIs</h2>

<p>Several APIs have been changed in significant ways. The most significant of these, which will likely affect a large number of extensions, are:</p>

<h3 id="DOM">DOM</h3>

<p>Nodes from external documents should be cloned using <a href="/en-US/docs/Web/API/Document/importNode" title="The Document object's importNode() method creates a copy of a Node or DocumentFragment from another document, to be inserted into the current document later."><code>document.importNode()</code></a> (or adopted using <a href="/en-US/docs/Web/API/Document/adoptNode" title="Document.adoptNode() transfers a node from another document into the method's document. The adopted node and its subtree is removed from its original document (if any), and its ownerDocument is changed to the current document. The node can then be inserted into the current document."><code>document.adoptNode()</code></a>) before they can be inserted into the current document. For more on the <a href="/en-US/docs/Web/API/Node/ownerDocument" title="The Node.ownerDocument read-only property returns the top-level document object for this node."><code>Node.ownerDocument</code></a> issues, see the <a class="external" href="http://www.w3.org/DOM/faq.html#ownerdoc" rel="noopener">W3C DOM FAQ</a>.</p>

<p>Firefox doesn't currently enforce this rule (it did for a while during the development of Firefox 3, but too many sites break when this rule is enforced). We encourage Web developers to fix their code to follow this rule for improved future compatibility.</p>

<h3 id="Bookmarks__History">Bookmarks &amp; History</h3>

<p>If your extension accesses bookmark or history data in any way, it will need substantial work to be compatible with Firefox 3. The old APIs for accessing this information have been replaced by the new <a href="/en-US/docs/Places" title="Places">Places</a> architecture. See the <a href="/en-US/docs/Places_Developer_Guide" title="Places_migration_guide">Places migration guide</a> for details on updating your existing extension to use the Places API.</p>

<h3 id="Download_Manager">Download Manager</h3>

<p>The Download Manager API has changed slightly due to the transition from an RDF data store to using the <a href="/en-US/docs/Storage" title="Storage">Storage</a> API. This should be a pretty easy transition to make. In addition, the API for monitoring download progress has changed to support multiple download manager listeners. See {{ Interface("nsIDownloadManager") }}, {{ Interface("nsIDownloadProgressListener") }}, and <a href="/en-US/docs/Monitoring_downloads" title="Monitoring_downloads">Monitoring downloads</a> for more information.</p>

<h3 id="Password_Manager">Password Manager</h3>

<p>If your extension accesses user login information using the Password Manager, it will need to be updated to use the new Login Manager API.</p>

<ul>
 <li>The article <a href="/en-US/docs/XPCOM_Interface_Reference/Using_nsILoginManager" title="Using_nsILoginManager">Using nsILoginManager</a> includes examples, including a demonstration of how to write your extension to work with both the Password Manager and the Login Manager, so it will work with both Firefox 3 and earlier versions.</li>
 <li><code><a href="/en-US/docs/XPCOM_Interface_Reference/nsILoginInfo" title="nsILoginInfo">nsILoginInfo</a></code></li>
 <li><code><a href="/en-US/docs/XPCOM_Interface_Reference/nsILoginManager" title="nsILoginManager">nsILoginManager</a></code></li>
</ul>

<p>You can also override the built-in password manager storage if you want to provide your own password storage implementation in your extensions. See <a href="/en-US/docs/Creating_a_Login_Manager_storage_module" title="Creating_a_Login_Manager_storage_module">Creating a Login Manager storage module</a> for details.</p>

<h3 id="Popups_.28Menus.2C_Context_Menus.2C_Tooltips_and_Panels.29">Popups (Menus, Context Menus, Tooltips and Panels)</h3>

<p>The XUL Popup system was heavily modified in Firefox 3. The Popup system includes main menus, context menus and popup panels. A guide to <a href="/en-US/docs/XUL/PopupGuide" title="XUL/PopupGuide">using Popups</a> has been created, detailing how the system works. One thing to note is that <code>popup.<span id="m-showPopup"><code><a href="/en-US/docs/Mozilla/Tech/XUL/Method/showPopup">showPopup</a></code></span></code> has been deprecated in favor of new <code>popup.<span id="m-openPopup"><code><a href="/en-US/docs/Mozilla/Tech/XUL/Method/openPopup">openPopup</a></code></span></code> and <code>popup.<span id="m-openPopupAtScreen"><code><a href="/en-US/docs/Mozilla/Tech/XUL/Method/openPopupAtScreen">openPopupAtScreen</a></code></span></code>.</p>

<h3 id="Autocomplete">Autocomplete</h3>

<p>The {{ Interface("nsIAutoCompleteController") }} interface's <code><a href="/en-US/docs/XPCOM_Interface_Reference/nsIAutoCompleteController#handleEnter.28.29" title="nsIAutoCompleteController#handleEnter.28.29">handleEnter()</a></code> method has been changed to accept an argument that indicates whether the text was selected from the autocomplete popup or by the user pressing enter after typing text.</p>

<h3 id="DOMParser">DOMParser</h3>

<ul>
 <li>When a <code>DOMParser</code> is instantiated, it inherits the calling code's principal and the <code>documentURI</code> and <code>baseURI</code> of the window the constructor came from.</li>
 <li>If the caller has UniversalXPConnect privileges, it can pass parameters to <code>new DOMParser()</code>. If fewer than three parameters are passed, the remaining parameters will default to <code>null</code>.
  <ul>
   <li>The first parameter is the principal to use; this overrides the default principal normally inherited.</li>
   <li>The second parameter is the <code>documentURI</code> to use.</li>
   <li>The third parameter is the <code>baseURI</code> to use.</li>
  </ul>
 </li>
 <li>If you initialize a <code>DOMParser</code> using a contract, such as by calling <code>createInstance()</code>, and you don't call the <code>DOMParser</code>'s <code>init()</code> method, attempting to initiate a parsing operation will automatically create and initialize the <code>DOMParser</code> with a null principal and <code>null</code> pointers for <code>documentURI</code> and <code>baseURI</code>.</li>
</ul>

<h3 id="Stop_using_the_internal_string_API">Stop using the internal string API</h3>

<p>The internal string API is no longer exported; you must migrate to the external string API. See these articles for helpful information:</p>

<ul>
 <li><a href="/en-US/docs/Mozilla_external_string_guide" title="Mozilla external string guide">Mozilla external string guide</a></li>
 <li><a href="/en-US/docs/XPCOM_Glue" title="XPCOM Glue">XPCOM Glue</a></li>
 <li><a href="/en-US/docs/Migrating_from_Internal_Linkage_to_Frozen_Linkage" title="Migrating from Internal Linkage to Frozen Linkage">Migrating from Internal Linkage to Frozen Linkage</a></li>
</ul>

<h3 id="Removed_interfaces">Removed interfaces</h3>

<p>The following interfaces were removed from Gecko 1.9, which drives Firefox 3. If your extension makes use of any of these, you'll need to update your code:</p>

<ul>
 <li><code>nsIDOMPaintListener</code></li>
 <li><code>nsIDOMScrollListener</code></li>
 <li><code>nsIDOMMutationListener</code></li>
 <li><code>nsIDOMPageTransitionListener</code></li>
 <li><code>nsICloseAllWindows</code> (see {{ Bug(386200) }})</li>
</ul>

<h2 id="Step_4_Check_for_relevant_chrome_changes">Step 4: Check for relevant chrome changes</h2>

<p>There have been a few changes to chrome layout that may affect some extensions.</p>

<h3 id="New_boxes">New boxes</h3>

<p>There has been a minor change to the chrome that may require changes in your code. A new <code>vbox</code> has been added, called "browser-bottombox", which encloses the find bar and status bar at the bottom of the browser window. Although this doesn't affect the appearance of the display, it may affect your extension if it overlays chrome relative to these elements.</p>

<p>For example, if you previously overlaid some chrome before the status bar, like this:</p>

<pre class="brush:xml">&lt;window id="main-window"&gt;
  &lt;something insertbefore="status-bar" /&gt;
&lt;/window&gt;
</pre>

<p>You should now overlay it like this:</p>

<pre class="brush:xml">&lt;vbox id="browser-bottombox"&gt;
  &lt;something insertbefore="status-bar" /&gt;
&lt;/vbox&gt;
</pre>

<p>Or use the following technique to make your overlay work on both Firefox 2 and Firefox 3:</p>

<pre class="brush:xml">&lt;window id="main-window"&gt;
  &lt;vbox id="browser-bottombox" insertbefore="status-bar"&gt;
    &lt;something insertbefore="status-bar" /&gt;
  &lt;/vbox&gt;
&lt;/window&gt;
</pre>

<h3 id="Changed_boxes">Changed boxes</h3>

<p>Extensions that attempt to overlay onto the "appcontent" box try to float chrome over document content will no longer display that material. You should update your extension to use the new <code><a href="/en-US/docs/Mozilla/Tech/XUL/panel">&lt;xul:panel&gt;</a></code> XUL element. If you wish to keep the panel from automatically disappearing after a delay, you can set the <code>noautohide</code> attribute to <code>true</code>.</p>

<h2 id="Other_changes">Other changes</h2>

<p><em>Add simple changes you had to make while updating your extension to work with Firefox 3 here.</em></p>

<ul>
 <li><code><a class="external" rel="freelink">chrome://browser/base/utilityOverlay.js</a></code> is no longer supported for security reasons. If you were previously using this, you should switch to <code><a class="external" rel="freelink">chrome://browser/content/utilityOverlay.js</a></code>.</li>
 <li>{{ Interface("nsIAboutModule") }} implementations are now required to support the <code>getURIFlags</code> method. See {{ Source("netwerk/protocol/about/public/nsIAboutModule.idl", "nsIAboutModule.idl") }} for documentation. This affects extensions that provide new <code>about:</code> URIs. ({{ Bug(337746) }})</li>
 <li>The <code><a href="/en-US/docs/Mozilla/Tech/XUL/tabbrowser">&lt;xul:tabbrowser&gt;</a></code> element is no longer part of "toolkit" ({{ Bug(339964) }}). This means this element is no longer available to XUL applications and extensions. It continues to be used in the main Firefox window (browser.xul).</li>
 <li>Changes to <a href="/en-US/docs/nsISupports_proxies" title="nsISupports_proxies">nsISupports proxies</a> and possibly to threading-related interfaces need to be documented.</li>
 <li>If you use XML processing instructions, such as <code>&lt;?xml-stylesheet ?&gt;</code> in your XUL files, be aware of the changes made in {{ Bug(319654) }}:
  <ol>
   <li>XML PIs are now added to a XUL document's DOM. This means {{ Domxref("document.firstChild") }} is no longer guaranteed to be the root element. If you need to get the root document in your script, use {{ Domxref("document.documentElement") }} instead.</li>
   <li><code>&lt;?xml-stylesheet ?&gt;</code> and <code>&lt;?xul-overlay ?&gt;</code> processing instructions now have no effect outside the document prolog.</li>
  </ol>
 </li>
 <li><code>window.addEventListener("load", myFunc, true)</code> is not fired when loading web content (browser page loads). This is due to {{ Bug(296639) }} which changes the way inner and outer windows communicate. The simple fix here is to use <code>gBrowser.addEventListener("load", myFunc, true)</code> as described <a href="/en-US/docs/Code_snippets/Tabbed_browser#Detecting_page_load" title="Code_snippets/Tabbed_browser#Detecting_page_load">here</a> and works in Firefox 2 as well.</li>
 <li><code>content.window.getSelection()</code> gives an object (which can be converted to a string by <code>toString()</code>), unlike the now deprecated <code>content.document.getSelection()</code> which returns a string</li>
 <li><code>event.preventBubble()</code> was deprecated in Firefox 2 and has been removed in Firefox 3. Use <a href="/en-US/docs/DOM/event.stopPropagation" title="DOM/event.stopPropagation"><code>event.stopPropagation()</code></a>, which works in Firefox 2 as well.</li>
 <li>Timers that are initiated using <code>setTimeout()</code> are now blocked by modal windows due to the fix made for {{ Bug(52209) }}. You may use {{ Interface("nsITimer") }} instead.</li>
 <li>If your extension needs to allow an untrusted source (e.g., a web site) to access the extension's chrome, then you must use the new <a href="/en-US/docs/Chrome_Registration#contentaccessible" title="Chrome_Registration#contentaccessible"><code>contentaccessible</code> flag</a>.</li>
</ul>
